<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>PersonService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">secretsanta</a> &gt; <a href="index.source.html" class="el_package">com.notthebest.demo.service</a> &gt; <span class="el_source">PersonService.java</span></div><h1>PersonService.java</h1><pre class="source lang-java linenums">package com.notthebest.demo.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.notthebest.demo.model.Person;
import com.notthebest.demo.repository.PersonRepo;

@Service
<span class="fc" id="L14">public class PersonService {</span>
	
	@Autowired
	private PersonRepo repo;
	
	public void deletePerson(int id) {
<span class="fc" id="L20">		Person person = repo.findById(id).get();</span>
<span class="fc" id="L21">		repo.delete(person);</span>
<span class="fc" id="L22">	}</span>
	
	public void addPerson(Person person) {
<span class="fc" id="L25">		repo.save(person);</span>
<span class="fc" id="L26">	}</span>
	public List&lt;Person&gt; getPeople() {
<span class="fc" id="L28">		return repo.findAll();</span>
	}
	
	public Map&lt;String, String&gt; generateMatches() {
<span class="fc" id="L32">		List&lt;Person&gt; list = getPeople();</span>
<span class="fc" id="L33">		int N = list.size();</span>
<span class="fc" id="L34">		boolean[] used =  new boolean[N];</span>
<span class="fc" id="L35">		int oddOneOut = -1;</span>
<span class="fc" id="L36">		Map&lt;String, String&gt; matches = new HashMap&lt;&gt;();</span>
		
<span class="fc bfc" id="L38" title="All 2 branches covered.">		if(N % 2 == 1) {</span>
<span class="fc" id="L39">			oddOneOut = randomMatch(N);</span>
<span class="fc" id="L40">			matches.put(list.get(oddOneOut).getName(), &quot;Nobody&quot;);</span>
		}
		
<span class="fc bfc" id="L43" title="All 2 branches covered.">		for(int i = 0; i&lt;N; i++) {</span>
<span class="fc bfc" id="L44" title="All 2 branches covered.">			if(i == oddOneOut) continue;</span>
			
<span class="fc" id="L46">			int match = randomMatch(N);</span>
<span class="pc bpc" id="L47" title="1 of 4 branches missed.">			while(match == i || used[match] == true) {</span>
<span class="fc" id="L48">				match = randomMatch(N);</span>
			}
<span class="fc" id="L50">			used[match] = true;</span>

<span class="fc" id="L52">			matches.put(list.get(i).getName(), list.get(match).getName());</span>
		}
		
<span class="fc" id="L55">		return matches;</span>
		
	}
	
	private int randomMatch(int size) {
<span class="fc" id="L60">		return (int)(Math.random()*size);</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.7.202105040129</span></div></body></html>